/*
 * PgGraph_CP.java
 *
 * Created on December 5, 2004, 6:17 PM
 */

package Grapher2D.geom;
import java.awt.*;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import jv.object.PsDebug;
import jv.object.PsPanel;
import jv.object.PsUpdateIf;
import jv.project.PgGeometryIf;
import Grapher2D.util.*;
/**
 *
 * @author David
 */
public class PgGraph_CP extends PsPanel implements ItemListener {
        protected	PgGraph                                 m_PgGraph;
        protected       PsPanel                                 m_pFunc;
	protected	PsPanel					m_pDomain;
        protected       Checkbox                                m_cUseGlobalDomain;
        
    /** Creates a new instance of Graph_CP */
    public PgGraph_CP() {
        super();
		if (getClass() == PgGraph_CP.class) {
			init();
		}
    }
    
    public void init() {
		super.init();
		addTitle("Graph");
             
                m_pFunc = new PsPanel();
                m_pFunc.setLayout(new GridLayout(1, 1));
                add(m_pFunc);
                
		m_pDomain = new PsPanel();
  		add(m_pDomain);
		
		addLine(1);
    }
    
    public void setParent(PsUpdateIf parent) {
		super.setParent(parent);
             
		m_PgGraph = (PgGraph)parent;
                
                setTitle("f(x) " + m_PgGraph.getName());
                
         //       m_pFunc.add(m_PgGraph.m_func2.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                m_pFunc.add(new PuFunc_IP(m_PgGraph.m_func2));   
                m_pDomain.add(m_PgGraph.m_domain.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                
                m_cUseGlobalDomain = new Checkbox("Use Global Domain");
                m_cUseGlobalDomain.addItemListener(this);
                m_pDomain.add(m_cUseGlobalDomain);

        }
    public boolean update(Object event) {
		if (PsDebug.NOTIFY) PsDebug.notify("isShowing = "+isShowing());
		return super.update(event);
	}
    
    public void itemStateChanged(ItemEvent event) {
		Object source = event.getSource();
                if (source == m_cUseGlobalDomain) {
                    m_PgGraph.m_bUseGlobalDomain = m_cUseGlobalDomain.getState();
                    m_PgGraph.m_domain.setEnabled(!m_PgGraph.m_bUseGlobalDomain);
                    if (m_PgGraph.m_bUseGlobalDomain) {
                        m_PgGraph.setDomain(m_PgGraph.globaldomain);
                    }
                }
    }
}
