/*
 * PjPCurve.java
 *
 * Created on December 5, 2004, 5:46 PM
 */

package Grapher2D.geom;

import java.awt.Color;

import jv.function.PuFunction;
import jv.number.PuDouble;
import jv.geom.PgPolygon;
import jv.number.PdColor;
import jv.number.PuInteger;
import jv.object.PsDebug;
import Grapher2D.util.PuDomain;


/**
 *
 * @author David
 */
public class PgPCurve extends PgPolygon {
    
//        protected       PgPolygon                       m_curve;
        protected       PuFunction                      m_func2;
        protected       PuDomain                        m_domain;
        protected       boolean                         m_bHasVf = false;
    
    /** Creates a new instance of PjPCurve */
    public PgPCurve(String PName) {
        super(2);
        if (getClass() == PgPCurve.class)
		  init(PName);
    }
    
    public void init(String PName) {
                    super.init();
                    
                    setName(PName);
                    
                    setGlobalEdgeColor(Color.black);
                    
                    m_func2 = new PuFunction(1,2);
                    m_func2.setName("Functions");
                    m_func2.setVariables(new String[] {"t"});
                    m_func2.setExpressionNames(new String[] {"x","y"});
                    m_func2.setExpressions(new String[] {"5*cos(t)","5*sin(t)"});
                    m_func2.setParent(this);
                    
                    m_domain = new PuDomain();
                    m_domain.setVars(new String[] {"t"});
                    m_domain.setDefVals(new double[] {0,2*Math.PI});
                    m_domain.setDefDiscr(new int[] {50});
                    m_domain.init();
                    m_domain.setParent(this);
                    
//                    assureVertexColors();
//                    showVertexColors(true);
                    showVertices(false);
//                    showEdgeColors(true);
                    setGlobalEdgeSize(2);
                    
                    computeCurve();
 	}
    
    public void start() {
		if (PsDebug.NOTIFY) PsDebug.notify("start: ");
    }

    public boolean update(Object event) {
		if (event == this) {
                        computeCurve();
			return super.update(this);
		} else if (event == m_domain) {

                        update(this);
			return true;
                } else if (event == m_func2) {
			update(this);
			return true;
                } 
                
		return super.update(event);
	}
    
     public void computeCurve() {
                int numVertices = m_domain.getDiscr(0);
                setNumVertices(numVertices);
                double u= m_domain.getMin(0);
                double deltaU = (m_domain.getMax(0)-u)/(numVertices-1.);
                for (int j=0; j<numVertices; j++) {
                 
                                
                                double x,y;
                                
                                    x = m_func2.eval(0,u);
                                    y = m_func2.eval(1,u);

                               
                                setVertex(j,x,y);
                                int dist	= 255*j/(numVertices-1);
				setVertexColor(j, PdColor.hsv2rgb(dist, 255, 255));		
				u += deltaU;
                                
		}
                makeEdgeFromVertexColors();
     }   
   
    
}
