/*
 * PgPiecewise.java
 *
 * Created on December 16, 2004, 8:28 AM
 */

package Grapher2D.geom;

import java.awt.Color;

import jv.function.PuFunction;
import jv.number.PuDouble;
import jv.object.PsPanel;
import jv.geom.PgPolygonSet;
import jv.number.PdColor;
import jv.number.PuInteger;
import jv.object.PsDebug;
import jv.vecmath.PdVector;
import jv.vecmath.PiVector;
import jv.object.PsObject;
import Grapher2D.util.PuDomain;



/**
 *
 * @author David
 */
public class PgPiecewise extends PgPolygonSet {
        static final    double                          DOM_LT = 0.0;
        static final    double                          DOM_LTE = 1.0;
        
        protected       PuFunction                      m_func2;
        protected       int                             numFuncs = 5;
        protected       double[][]                      m_doms;
        protected       int                             m_discr = 50;
        protected       boolean                         m_bHasVf = false;
        
	public PgPiecewise(String PName) {
            super(2);
	    if (getClass() == PgPiecewise.class)
		  init(PName);
	}
        
	public void init(String PName) {
               
            super.init();
            setName(PName);
                  
  
                   
                    
                    m_func2 = new PuFunction(1,5);
                    m_func2.setName("Functions");
                    m_func2.setVariables(new String[] {"x"});
                    m_func2.setExpressionNames(new String[] {"f","g","h","j","k"});
                    m_func2.setExpressions(new String[] {"x","x+1","x+2","x+3","x+4"});
                    m_func2.setParent(this);
                    
                    m_doms = new double[5][4];
                    for (int i=0;i<5;i++) {
                        m_doms[i][0] = -3.0;
                        m_doms[i][1] = DOM_LT;
                        m_doms[i][2] = DOM_LTE;
                        m_doms[i][3] = 3.0;
                    }
                    
                    
                 
                    
                    
		
 	}
	public void start() {
		if (PsDebug.NOTIFY) PsDebug.notify("start: ");

	}
	/**
	 * Update the class whenever a child has changed.
	 * Method is usually invoked from the children.
	 */
	public boolean update(Object event) {
		if (event == this) {
                        computeGraph();
			return super.update(this);
		} else if (event == m_doms) {
                        update(this);
			return true;
                } else if (event == m_func2) {
                        update(this);
			return true;
                }
                
		return super.update(event);
	}

	public void computeGraph() {
           
 //          setNumVertices(m_discr*numFuncs);
           
           showVertices(false);
           setNumPolygons(numFuncs*3);
           showPolygonSizes(true);
           assurePolygonSizes();
           for (int j = 0; j < numFuncs; j++) { 
                
                int[] verts = new int[m_discr];
                double x = m_doms[j][0];

                double deltaX= (m_doms[j][3]-x)/(m_discr-1.);//(m_domain.getMax(0)-x)/(xlines-1.);
               
                double y;
		for (int i=0; i<m_discr; i++) {
                     y = m_func2.eval(j,x);
//                     setVertex(m_discr*j+i, new PdVector(x,y));
//                     verts[i] = m_discr*j+i;
                    verts[i] = addVertex(new PdVector(x,y));
                     x += deltaX;
		}
                setPolygonSize(j,1);              
		setPolygon(j, new PiVector(verts));
                
                int[] circleverts = new int[10];
                
                if (m_doms[j][1]==DOM_LT) {
                    x = getVertex(verts[0]).getEntry(0);
                    y = getVertex(verts[0]).getEntry(1);
                    for (int i=0;i<10;i++) {
                        double t = i*(2*Math.PI/9);
                        circleverts[i] = addVertex(new PdVector(x+.1*Math.cos(t),y+.1*Math.sin(t)));
                    }
                    setPolygonSize(j+numFuncs,1);
                    setPolygon(j+numFuncs, new PiVector(circleverts));
                } else {
                    setPolygonSize(j+numFuncs,4);
                    setPolygon(j+numFuncs, verts[0], verts[0]);
                }
                if (m_doms[j][2]==DOM_LT) {
                    x = getVertex(verts[m_discr-1]).getEntry(0);
                    y = getVertex(verts[m_discr-1]).getEntry(1);
                    for (int i=0;i<10;i++) {
                        double t = i*(2*Math.PI/9);
                        circleverts[i] = addVertex(new PdVector(x+.1*Math.cos(t),y+.1*Math.sin(t)));
                    }
                    setPolygonSize(j+2*numFuncs,1);
                    setPolygon(j+2*numFuncs, new PiVector(circleverts));
                } else {
                    setPolygonSize(j+2*numFuncs,4);
                    setPolygon(j+2*numFuncs, verts[m_discr-1], verts[m_discr-1]);
                }
                
                
           }
           
	}
        
        
    
}
