/*
 * PgPiecewise_CP.java
 *
 * Created on December 16, 2004, 8:28 AM
 */

package Grapher2D.geom;

import java.awt.*;

import jv.object.PsDebug;
import jv.object.PsPanel;
import jv.object.PsUpdateIf;
import jv.project.PgGeometryIf;
import jv.objectGui.PsSlotLayout;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 *
 * @author David
 */
public class PgPiecewise_CP extends PsPanel implements ItemListener, ActionListener {
        protected	PgPiecewise                             m_PgPiecewise;
        protected       PsPanel                                 m_pSel;
        protected       PsPanel                                 m_pFunc;
	protected	PsPanel					m_pDomain;
        protected       PsPanel[]                               m_pDomSubs;
        protected       TextField[]                             funcs;
        protected       TextField[][]                           doms;
        protected       Choice[][]                              domslt;
        protected       Choice                                  m_sNumFunc;
        protected       Button                                  m_bReCalc;
        
    /** Creates a new instance of Graph_CP */
    public PgPiecewise_CP() {
        super();
		if (getClass() == PgPiecewise_CP.class) {
			init();
		}
    }
    
    public void init() {
		super.init();
		addTitle("Graph");
                
                m_pSel = new PsPanel(new GridLayout(2,2));
                add(m_pSel);
//                m_pFunc = new PsPanel();
//                m_pFunc.setLayout(new GridLayout(1, 1));
 //               add(m_pFunc);
                
		m_pDomain = new PsPanel();
  		add(m_pDomain);
		
		addLine(1);
    }
    
    public void setParent(PsUpdateIf parent) {
		super.setParent(parent);
             
		m_PgPiecewise = (PgPiecewise)parent;
                m_pSel.add(new Label("Number of Pieces:"));
                m_sNumFunc = new Choice();
                m_sNumFunc.addItemListener(this);
                m_sNumFunc.add("1");
                m_sNumFunc.add("2");
                m_sNumFunc.add("3");
                m_sNumFunc.add("4");
                m_sNumFunc.add("5");
                m_sNumFunc.select(4);
                m_pSel.add(m_sNumFunc);
                m_bReCalc = new Button("ReCalc Graph");
                m_bReCalc.addActionListener(this);
                m_pSel.add(m_bReCalc);
                showPanel();
 //               setTitle("f(x) " + m_PgPiecewise.getName());
                
 //               m_pFunc.add(m_PgPiecewise.m_func2.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                   
 //               m_pDomain.add(m_PgPiecewise.m_domain.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                updateFuncs();
                m_PgPiecewise.computeGraph();

        }
    public boolean update(Object event) {
		if (PsDebug.NOTIFY) PsDebug.notify("isShowing = "+isShowing());
		return super.update(event);
	}
    
    public void itemStateChanged(ItemEvent event) {
		Object source = event.getSource();
                if (source == m_sNumFunc) {
                    m_PgPiecewise.numFuncs = m_sNumFunc.getSelectedIndex()+1;
                    showPanel();
                }
    }
    
    public void actionPerformed(ActionEvent event) {
		
		Object source = event.getSource();
                if (source == m_bReCalc) {
                    updateFuncs();
                   
                }
    }
    
    public void showPanel() {
        m_pDomain.removeAll();
        m_pDomain.setLayout(new GridLayout(m_PgPiecewise.numFuncs,1));
        m_pDomSubs = new PsPanel[m_PgPiecewise.numFuncs];
        funcs = new TextField[m_PgPiecewise.numFuncs];
        doms = new TextField[m_PgPiecewise.numFuncs][2];
        domslt = new Choice[m_PgPiecewise.numFuncs][2];
        for (int i=0; i< m_PgPiecewise.numFuncs;i++) {
            m_pDomSubs[i] = new PsPanel(new PsSlotLayout(14));
            funcs[i] = new TextField("x + " + i);
            doms[i][0] = new TextField("-5");
            doms[i][1] = new TextField("5");
            domslt[i][0] = new Choice();
            domslt[i][1] = new Choice();
            domslt[i][0].add("<");
            domslt[i][0].add("<=");
            domslt[i][1].add("<");
            domslt[i][1].add("<=");
            m_pDomSubs[i].add("4", funcs[i]);
            m_pDomSubs[i].add("1", new Label("on"));
            m_pDomSubs[i].add("2", doms[i][0]);
            m_pDomSubs[i].add("2", domslt[i][0]);
            m_pDomSubs[i].add("1", new Label("x"));
            m_pDomSubs[i].add("2", domslt[i][1]);
            m_pDomSubs[i].add("2", doms[i][1]);
            m_pDomain.add(m_pDomSubs[i]);
            update(m_pDomain);
            validate();
            m_PgPiecewise.update(m_PgPiecewise);
        }
        
    }
    
    public void updateFuncs() {
         for (int i=0; i< m_PgPiecewise.numFuncs; i++) {
                        m_PgPiecewise.m_func2.setExpression(i,funcs[i].getText());
                        m_PgPiecewise.m_doms[i][0] = Double.valueOf(doms[i][0].getText()).doubleValue();
                        m_PgPiecewise.m_doms[i][1] = (double) domslt[i][0].getSelectedIndex();
                        m_PgPiecewise.m_doms[i][2] = (double) domslt[i][1].getSelectedIndex();
                        m_PgPiecewise.m_doms[i][3] = Double.valueOf(doms[i][1].getText()).doubleValue();
                    }
                    m_PgPiecewise.update(m_PgPiecewise);
    }
}
