/*
 * PuFunc_IP.java
 *
 * Created on January 27, 2005, 5:55 PM
 */

package Grapher2D.util;

import java.awt.*;
import java.awt.event.*;
import jv.object.PsDebug;
import jv.object.PsPanel;
import jv.function.*;
import jv.objectGui.*;
import jv.object.PsUpdateIf;
import jv.project.PgGeometryIf;
/**
 *
 * @author  David
 */
public class PuFunc_IP extends PsPanel implements ActionListener, FocusListener {
    protected   PsPanel[]           inputs;
   protected    TextField[]       texts;
   protected    PuFunction          func;
   protected    int                 numfunc;
   
    /** Creates a new instance of PuFunc_IP */
    public PuFunc_IP(PuFunction func2) {
        super();
        func = func2;
        
       
       numfunc = func.getNumFunctions();
     //  setLayout(new GridLayout(numfunc,1));
       inputs = new PsPanel[numfunc];
       texts = new TextField[numfunc];
       StringBuffer explabel = new StringBuffer();
       for (int j=0;j<numfunc;j++) {
        inputs[j] = new PsPanel(new PsSlotLayout(3));
        explabel.setLength(0);
        explabel.append(func.getExpressionName(j));
        explabel.append("(");
        for (int i=0; i < func.getNumVariables(); i++) {
            if (i!=0) { explabel.append(",");}
            explabel.append(func.getVariables()[i]);            
        }
        explabel.append(")");
        inputs[j].add("1", new Label(explabel.toString()));
        texts[j] = new TextField(func.getExpression(j));
        texts[j].addActionListener(this);
        texts[j].addFocusListener(this);
        inputs[j].add("2", texts[j]);
       
        add(inputs[j]);
       }
        
    }
    
    public void actionPerformed(ActionEvent event) {
        Object source = event.getSource();
        for (int i=0; i<numfunc;i++) {
          if (source == texts[i]) {
              
            func.setExpression(i,texts[i].getText());
            func.update(func);
          }    
        }
    }
    
    public void focusGained(FocusEvent e) {
    }
    
    public void focusLost(FocusEvent event) {
      Object source = event.getSource();
      for (int i=0; i<numfunc;i++) {
        if (source == texts[i]) {
          if (!texts[i].getText().equals(func.getExpression(i))) {  
            func.setExpression(i,texts[i].getText());
            func.update(func);
          }
        }
      }
     }
    
}
